# TODO:
# - real webapps integration

%define gituser   git

Summary:	Gitolite setup used by PLD
Name:		pld-gitolite
Version:	0.11
Release:	0.1
License:	GPL v2
Group:		Development/Building
Source0:	https://github.com/draenog/gitolite-scripts/tarball/v%{version}/gitolite-scripts.tar.gz
# Source0-md5:	44f58773a1353c7a78b2627bee082377
Source1:	gitolite.conf
Source2:	gitolite.rc
Source3:	git.conf
Source4:	gitweb.conf
Source5:	pld-developers
BuildRequires:	rpmbuild(macros) >= 1.202
Requires:	git-core-slug
Requires:	gitolite
Requires:	perl-RPC-XML
Provides:	group(%gituser)
Provides:	user(%gituser)
Requires(postun):	/usr/sbin/groupdel
Requires(pre):	/usr/bin/getgid
Requires(pre):	/usr/sbin/groupadd
Requires(postun):	/usr/sbin/userdel
Requires(pre):	/bin/id
Requires(pre):	/usr/sbin/useradd
Suggests:	git-core-daemon
Suggests:	git-core-gitweb
BuildArch:	noarch
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%description
Gitolite setup used by PLD Linux Distribution

%prep
%setup -qc
mv draenog-gitolite-scripts-*/* .

%install
rm -rf $RPM_BUILD_ROOT
# create directories if necessary
install -d $RPM_BUILD_ROOT/home/services/%gituser/.gitolite/{conf,hooks/common}

cp -p %{SOURCE1} %{SOURCE5} $RPM_BUILD_ROOT/home/services/%gituser/.gitolite/conf
cp -p %{SOURCE2} $RPM_BUILD_ROOT/home/services/%gituser/.gitolite.rc
cp -p %{SOURCE3} $RPM_BUILD_ROOT/home/services/%gituser/.gitconfig
cp -a hooks/* $RPM_BUILD_ROOT/home/services/%gituser/.gitolite/hooks/common
cp -a adc $RPM_BUILD_ROOT/home/services/%gituser

install -D %{SOURCE4} $RPM_BUILD_ROOT%{_sysconfdir}/webapps/gitweb/gitweb-pld.conf

%clean
rm -rf $RPM_BUILD_ROOT

%pre
%groupadd -g 264 %gituser
%useradd -u 264 -d /home/services/%gituser -s /bin/sh -g %gituser -c "PLD Gitolite User" %gituser

%postun
if [ "$1" = "0" ]; then
	%userremove %gituser
	%groupremove %gituser
fi

%files
%defattr(644,root,root,755)
%attr(640,root,http) %config(noreplace) %verify(not md5 mtime size) %{_sysconfdir}/webapps/gitweb/gitweb-pld.conf

# all files owned by %gituser:%gituser
%defattr(644,%gituser,%gituser,755)

%dir /home/services/%gituser
%config(noreplace) %verify(not md5 mtime size) /home/services/%gituser/.gitconfig

%dir /home/services/%gituser/.gitolite
%config(noreplace) %verify(not md5 mtime size) /home/services/%gituser/.gitolite.rc

%dir /home/services/%gituser/.gitolite/conf
%config(noreplace) %verify(not md5 mtime size) /home/services/%gituser/.gitolite/conf/gitolite.conf
%config(noreplace) %verify(not md5 mtime size) /home/services/%gituser/.gitolite/conf/pld-developers

%dir /home/services/%gituser/.gitolite/hooks
%dir /home/services/%gituser/.gitolite/hooks/common
%attr(744,%gituser,%gituser) /home/services/%gituser/.gitolite/hooks/common/update.secondary
%attr(744,%gituser,%gituser) /home/services/%gituser/.gitolite/hooks/common/post-receive
%dir /home/services/%gituser/.gitolite/hooks/common/post-receive.d
%attr(744,%gituser,%gituser) /home/services/%gituser/.gitolite/hooks/common/post-receive.d/setdescription.sh
/home/services/%gituser/.gitolite/hooks/common/post-receive.python.d
%dir /home/services/%gituser/.gitolite/hooks/common/post-receive.d/misc
%attr(744,%gituser,%gituser) /home/services/%gituser/.gitolite/hooks/common/post-receive.d/misc/ciabot.pl
%dir /home/services/%gituser/.gitolite/hooks/common/post-receive.d/gnome
%attr(744,%gituser,%gituser) /home/services/%gituser/.gitolite/hooks/common/post-receive.d/gnome/gnome-post-receive-email
/home/services/%gituser/.gitolite/hooks/common/post-receive.d/gnome/*.py
/home/services/%gituser/.gitolite/hooks/common/post-receive.d/gnome-post-receive-email
%dir /home/services/%gituser/adc
%dir /home/services/%gituser/adc/bin
%attr(744,%gituser,%gituser) /home/services/%gituser/adc/bin/create
%attr(744,%gituser,%gituser) /home/services/%gituser/adc/bin/sskm
/home/services/%gituser/adc/bin/adc.common-functions
%changelog
* Mon Jul 09 2012 Kacper Kornet <draenog@pld-linux.org> cf7547c
- up to 0.11

* Wed Jul 04 2012 Kacper Kornet <draenog@pld-linux.org> a65f81b
- up to 0.10

* Tue Jul 03 2012 Kacper Kornet <draenog@pld-linux.org> c48215e
- limit size of email

* Tue Jul 03 2012 Kacper Kornet <draenog@pld-linux.org> ab1c120
Variables to set watchdir and Attic directories

* Mon Jul 02 2012 Kacper Kornet <draenog@pld-linux.org> 123a721
- show urls to clone a repository in gitweb

* Wed Jun 27 2012 Kacper Kornet <draenog@pld-linux.org> d20f156
- gitolite -> git in gitweb configuration file

* Wed Jun 27 2012 Kacper Kornet <draenog@pld-linux.org> 8d86590
- disable mailinglists and ciabot for test times

* Tue Jun 26 2012 Kacper Kornet <draenog@pld-linux.org> 6fd2668
- accept '#' in ref names

* Sun Jun 24 2012 Kacper Kornet <draenog@pld-linux.org> 36a1b2b
- don't package repositories dir; it doesn't have to be in ~git subdir

* Sun Jun 24 2012 Kacper Kornet <draenog@pld-linux.org> 04c7c93
- don't use @all group with sskm, as it can result in commits authored by
  zzz-marked-for-add-<nick>

* Sun Jun 24 2012 Kacper Kornet <draenog@pld-linux.org> d66cc56
- make loginname configurable
- git@git looks better then gitolite@git

* Sat Jun 16 2012 Kacper Kornet <draenog@pld-linux.org> 71b2700
- up to 0.8
- don't use @all group with sskm, as it can result in commits authored by
  zzz-marked-for-add-<nick>
- fix gid of gitweb configuration file

* Sat Jun 16 2012 Kacper Kornet <draenog@pld-linux.org> e4ef19b
- configuration for ciabot

* Sat Jun 16 2012 Kacper Kornet <draenog@pld-linux.org> 9254d65
- use the name of options to the ones in git-core-gitweb-1.7.11

* Sat Jun 16 2012 Kacper Kornet <draenog@pld-linux.org> 30f9d00
- slug_watch takes care about gitweb access

* Thu Apr 05 2012 Kacper Kornet <draenog@pld-linux.org> 32afe8e
- up to 0.6
- R: perl-RPC-XML for ciabot
- S: git-core-daemon, git-core-gitweb

* Mon Apr 02 2012 Elan Ruusamäe <glen@pld-linux.org> fc29bd7
- no double slashes, webapps todo

* Mon Apr 02 2012 Kacper Kornet <draenog@pld-linux.org> 04a812a
- up to 0.4
- config files for gitweb and mailing lists

* Sun Apr 01 2012 Kacper Kornet <draenog@pld-linux.org> d165fdd
- up to 0.3

* Fri Mar 16 2012 Kacper Kornet <draenog@pld-linux.org> 979356d
- up to 0.2

